"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createAnimate;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _createNodeGroup = _interopRequireDefault(require("../createNodeGroup"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var keyAccessor = function keyAccessor() {
  return '$$key$$';
};

function createAnimate(getInterpolater) {
  var _class, _temp;

  var displayName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Animate';
  var NodeGroup = (0, _createNodeGroup.default)(getInterpolater, "".concat(displayName, "(NodeGroup)"));
  return _temp = _class =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Animate, _Component);

    function Animate() {
      _classCallCheck(this, Animate);

      return _possibleConstructorReturn(this, _getPrototypeOf(Animate).apply(this, arguments));
    }

    _createClass(Animate, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            show = _this$props.show,
            start = _this$props.start,
            enter = _this$props.enter,
            update = _this$props.update,
            leave = _this$props.leave,
            wrapper = _this$props.wrapper,
            wrapperClass = _this$props.wrapperClass,
            wrapperStyle = _this$props.wrapperStyle,
            children = _this$props.children;
        var data = typeof start === 'function' ? start() : start;
        return _react.default.createElement(NodeGroup, {
          data: show ? [data] : [],
          start: function start() {
            return data;
          },
          keyAccessor: keyAccessor,
          enter: typeof enter === 'function' ? enter : function () {
            return enter;
          },
          update: typeof update === 'function' ? update : function () {
            return update;
          },
          leave: typeof leave === 'function' ? leave : function () {
            return leave;
          },
          wrapper: wrapper,
          wrapperClass: wrapperClass,
          wrapperStyle: wrapperStyle
        }, children);
      }
    }]);

    return Animate;
  }(_react.Component), _defineProperty(_class, "displayName", displayName), _defineProperty(_class, "propTypes", {
    show: _propTypes.default.bool.isRequired,
    start: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object]).isRequired,
    enter: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.array, _propTypes.default.object]),
    update: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.array, _propTypes.default.object]),
    leave: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.array, _propTypes.default.object]),
    wrapper: _propTypes.default.string,
    wrapperClass: _propTypes.default.string,
    wrapperStyle: _propTypes.default.object,
    children: _propTypes.default.object.isRequired
  }), _defineProperty(_class, "defaultProps", {
    show: true
  }), _temp;
}