import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import createNodeGroup from '../createNodeGroup';

var keyAccessor = function keyAccessor() {
  return '$$key$$';
};

export default function createAnimate(getInterpolater) {
  var _class, _temp;

  var displayName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Animate';
  var NodeGroup = createNodeGroup(getInterpolater, "".concat(displayName, "(NodeGroup)"));
  return _temp = _class =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Animate, _Component);

    function Animate() {
      _classCallCheck(this, Animate);

      return _possibleConstructorReturn(this, _getPrototypeOf(Animate).apply(this, arguments));
    }

    _createClass(Animate, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            show = _this$props.show,
            start = _this$props.start,
            enter = _this$props.enter,
            update = _this$props.update,
            leave = _this$props.leave,
            wrapper = _this$props.wrapper,
            wrapperClass = _this$props.wrapperClass,
            wrapperStyle = _this$props.wrapperStyle,
            children = _this$props.children;
        var data = typeof start === 'function' ? start() : start;
        return React.createElement(NodeGroup, {
          data: show ? [data] : [],
          start: function start() {
            return data;
          },
          keyAccessor: keyAccessor,
          enter: typeof enter === 'function' ? enter : function () {
            return enter;
          },
          update: typeof update === 'function' ? update : function () {
            return update;
          },
          leave: typeof leave === 'function' ? leave : function () {
            return leave;
          },
          wrapper: wrapper,
          wrapperClass: wrapperClass,
          wrapperStyle: wrapperStyle
        }, children);
      }
    }]);

    return Animate;
  }(Component), _defineProperty(_class, "displayName", displayName), _defineProperty(_class, "propTypes", {
    show: PropTypes.bool.isRequired,
    start: PropTypes.oneOfType([PropTypes.func, PropTypes.object]).isRequired,
    enter: PropTypes.oneOfType([PropTypes.func, PropTypes.array, PropTypes.object]),
    update: PropTypes.oneOfType([PropTypes.func, PropTypes.array, PropTypes.object]),
    leave: PropTypes.oneOfType([PropTypes.func, PropTypes.array, PropTypes.object]),
    wrapper: PropTypes.string,
    wrapperClass: PropTypes.string,
    wrapperStyle: PropTypes.object,
    children: PropTypes.object.isRequired
  }), _defineProperty(_class, "defaultProps", {
    show: true
  }), _temp;
}